"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const transform_1 = require("./transform");
exports.default = createPlugin;
function createPlugin(mdxOptions = {}) {
    var _a, _b;
    (_a = mdxOptions.remarkPlugins) !== null && _a !== void 0 ? _a : (mdxOptions.remarkPlugins = []);
    (_b = mdxOptions.rehypePlugins) !== null && _b !== void 0 ? _b : (mdxOptions.rehypePlugins = []);
    return {
        name: 'vite-plugin-mdx',
        mdxOptions: mdxOptions,
        configResolved(config) {
            const reactRefresh = config.plugins.find((p) => p.name === 'react-refresh');
            this.transform = function (code, id, ssr) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (/\.mdx?$/.test(id)) {
                        code = yield transform_1.transform(code, mdxOptions, config.root);
                        const refreshResult = yield (reactRefresh === null || reactRefresh === void 0 ? void 0 : reactRefresh.transform.call(this, code, id + '.js', ssr));
                        return refreshResult || code;
                    }
                });
            };
        },
        closeBundle() {
            return __awaiter(this, void 0, void 0, function* () {
                yield transform_1.stopService();
            });
        }
    };
}
//# sourceMappingURL=index.js.map